> For the complete documentation index, see [llms.txt](https://docs.cloudio.io/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.cloudio.io/creating-datasources/working-with-datasources/creating-a-data-source/defining-a-pre-query/pre-query-variables.md).

# Pre-query variables

| **Variable**       | **Description**                                                                                                                                                                                                 | **Datatype**        |
| ------------------ | --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | ------------------- |
|                    |                                                                                                                                                                                                                 |                     |
| **data**           | An RPCModelData instance that contains user's input from the search panel                                                                                                                                       | RPCModelData        |
| **whereClause**    | The system generated whereClause, if any                                                                                                                                                                        | StringBuilder       |
| **params**         | Binds values in an array of objects                                                                                                                                                                             | ArrayList\<Object>  |
| **selectClause**   | The select portion of the SQL query                                                                                                                                                                             | StringBuilder       |
| **fromClause**     | The from portion of the query                                                                                                                                                                                   | StringBuilder       |
| **orderByClause**  | The order by clause of the query, if any                                                                                                                                                                        | StringBuilder       |
| **fullSQL**        | selectClause + fromClause + whereClause + orderByClause                                                                                                                                                         | StringBuilder       |
| **db**             | An instance of ScriptUtil class                                                                                                                                                                                 | NA                  |
| **dateUtils**      | An instance of DateUtils class                                                                                                                                                                                  | NA                  |
| **user**           | The username of the signed in user                                                                                                                                                                              | NA                  |
| **userid**         | Userid of the signed in user                                                                                                                                                                                    | Double              |
| **subDomain**      | The subdomain of the current application                                                                                                                                                                        | NA                  |
| **dsName**         | The alias name of the current datasource                                                                                                                                                                        | NA                  |
| **skipQuery**      | To skip the query execution, set this to true while [defining datasource details](/creating-datasources/working-with-datasources/creating-a-data-source/defining-data-source-details.md)                        | boolean             |
| **rows**           | The data to be returned to the browser when skipQuery is set to true while [defining datasource details](/creating-datasources/working-with-datasources/creating-a-data-source/defining-data-source-details.md) | List\<RPCModelData> |
| **skipPagination** | To fetch all the rows in at once, set this to **Y** while [defining datasource details](/creating-datasources/working-with-datasources/creating-a-data-source/defining-data-source-details.md)                  | NA                  |


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.cloudio.io/creating-datasources/working-with-datasources/creating-a-data-source/defining-a-pre-query/pre-query-variables.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
